Get the packages and Git references that were used in a Runbook run
GET /api
Also reachable at /api.
Path Parameters
idstring (required)
ID of the Runbook run to load packages for.projectIdstring (required)
ID of the Project to get Runbook run packages for.spaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — Packages and Git references that were used in a Runbook run
GitResourcesarray of objectActionNamestring
Minimum length 1.DefaultBranchstring
Minimum length 1.FilePathFiltersarray of stringGitCredentialIdstringGitHubConnectionIdstringGitResourceSelectedLastReleaseobjectIsResolvablebooleanNamestringRepositoryUristring
Minimum length 1.
Packagesarray of objectActionNamestringFeedIdstringFeedNamestringFixedVersionstringIsResolvableboolean
Gets or sets a value indicating whether the PackageId or FeedId contain no references to other variables. Variables can be used to select different NuGet feeds or packages at deployment time, however, this means that it’s not possible to resolve which feed/package to search when creating a release.NuGetFeedIdstringNuGetFeedNamestringNuGetPackageIdstringPackageIdstringPackageReferenceNamestringProjectNamestringStepNamestringVersionSelectedLastReleasestring
Example Response
{
"GitResources": [
{
"ActionName": "string",
"DefaultBranch": "string",
"FilePathFilters": [
"string"
],
"GitCredentialId": "string",
"GitHubConnectionId": "string",
"GitResourceSelectedLastRelease": {
"GitCommit": "string",
"GitRef": "string"
},
"IsResolvable": true,
"Name": "string",
"RepositoryUri": "string"
}
],
"Packages": [
{
"ActionName": "string",
"FeedId": "string",
"FeedName": "string",
"FixedVersion": "string",
"IsResolvable": true,
"NuGetFeedId": "string",
"NuGetFeedName": "string",
"NuGetPackageId": "string",
"PackageId": "string",
"PackageReferenceName": "string",
"ProjectName": "string",
"StepName": "string",
"VersionSelectedLastRelease": "string"
}
]
}Get a paginated list of all of the Runbook Snapshots that belong to the given Project
GET /api
Also reachable at /api, /api.
Runbook Snapshots will be ordered from most recent to least recent.
Path Parameters
projectIdstring (required)
The ID of the project to get runbook snapshots for.spaceIdstring (required)
The ID of the space containing the resource(s).
Query Parameters
searchByNamestring
A partial or complete name to search on. This will perform a “contains” style match against the supplied name or name-fragment.skipinteger
Number of items to skip. Defaults to zero. Minimum0.takeinteger
Number of items to take. Defaults to 30. Minimum0.
Response
200 — A paginated list of all of the Runbook Snapshots that belong to the given Project.
Idstring
Gets or sets a unique identifier for this resource.ItemTypestringItemsarray of objectAssembledstring
Formatdate-time.FrozenProjectVariableSetIdstring
Minimum length 1.FrozenRunbookProcessIdstring
Minimum length 1.GitReferenceobjectIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LibraryVariableSetSnapshotIdsarray of string
Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Minimum length 1.NotesstringProjectIdstringProjectVariableSetSnapshotIdstring
Minimum length 1.RunbookIdstringSelectedGitResourcesarray of objectSelectedPackagesarray of objectSpaceIdstring
ItemsPerPageintegerLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LastPageNumberintegerLinksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NumberOfPagesintegerTotalResultsinteger
Example Response
{
"Id": "string",
"ItemType": "string",
"Items": [
{
"Assembled": "2020-01-01T00:00:00.000Z",
"FrozenProjectVariableSetId": "string",
"FrozenRunbookProcessId": "string",
"GitReference": {
"GitCommit": "string",
"GitRef": "string",
"VariablesGitCommit": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LibraryVariableSetSnapshotIds": [
"string"
],
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Notes": "string",
"ProjectId": "Projects-1",
"ProjectVariableSetSnapshotId": "string",
"RunbookId": "Runbooks-1",
"SelectedGitResources": [
{}
],
"SelectedPackages": [
{}
],
"SpaceId": "Spaces-1"
}
],
"ItemsPerPage": 0,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LastPageNumber": 0,
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"NumberOfPages": 0,
"TotalResults": 0
}Create a Runbook Snapshot
POST /api
Also reachable at /api, /api.
Path Parameters
projectIdstring (required)
ID of the project that owns the runbook to snapshot.spaceIdstring (required)
The ID of the space containing the resource(s).
Request Body
Namestring (required)
The name of the runbook snapshot. Minimum length 1.Notesstring
Any additional information about the runbook snapshot.ProjectIdstring (required)
ID of the project that owns the runbook to snapshot.Publishstring
Publishes the snapshot when set to any non-blank value, making it the snapshot that runbook triggers and ‘published’ runs use. The value itself is not stored. Leave unset to create the snapshot without publishing it.RunbookIdstring (required)
ID of the runbook to snapshot.SelectedGitResourcesarray of objectActionNamestring (required)
Minimum length 1.GitReferenceResourceobject (required)GitResourceReferenceNamestring
SelectedPackagesarray of object
The packages and versions used in the runbook snapshot.ActionNamestringPackageReferenceNamestringStepNamestringVersionstring
SpaceIdstring (required)
The ID of the space containing the resource(s).
Response
201 — Created
Assembledstring
Formatdate-time.FrozenProjectVariableSetIdstring
Minimum length 1.FrozenRunbookProcessIdstring
Minimum length 1.GitReferenceobjectGitCommitstringGitRefstringVariablesGitCommitstring
Idstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LibraryVariableSetSnapshotIdsarray of string
Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Minimum length 1.NotesstringProjectIdstringProjectVariableSetSnapshotIdstring
Minimum length 1.RunbookIdstringSelectedGitResourcesarray of objectActionNamestring
Minimum length 1.GitReferenceResourceobjectGitResourceReferenceNamestring
SelectedPackagesarray of objectActionNamestringPackageReferenceNamestringStepNamestringVersionstring
SpaceIdstring
Example Request
{
"Name": "string",
"Notes": "string",
"ProjectId": "Projects-1",
"Publish": "string",
"RunbookId": "Runbooks-1",
"SelectedGitResources": [
{
"ActionName": "string",
"GitReferenceResource": {
"GitCommit": "string",
"GitRef": "string"
},
"GitResourceReferenceName": "string"
}
],
"SelectedPackages": [
{
"ActionName": "string",
"PackageReferenceName": "string",
"StepName": "string",
"Version": "string"
}
],
"SpaceId": "Spaces-1"
}Example Response
{
"Assembled": "2020-01-01T00:00:00.000Z",
"FrozenProjectVariableSetId": "string",
"FrozenRunbookProcessId": "string",
"GitReference": {
"GitCommit": "string",
"GitRef": "string",
"VariablesGitCommit": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LibraryVariableSetSnapshotIds": [
"string"
],
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Notes": "string",
"ProjectId": "Projects-1",
"ProjectVariableSetSnapshotId": "string",
"RunbookId": "Runbooks-1",
"SelectedGitResources": [
{
"ActionName": "string",
"GitReferenceResource": {
"GitCommit": "string",
"GitRef": "string"
},
"GitResourceReferenceName": "string"
}
],
"SelectedPackages": [
{
"ActionName": "string",
"PackageReferenceName": "string",
"StepName": "string",
"Version": "string"
}
],
"SpaceId": "Spaces-1"
}Get a single Runbook Snapshot by project ID and name
GET /api
Also reachable at /api, /api.
Path Parameters
idOrNamestring (required)
ID or Name of the RunbookSnapshot to load.projectIdstring (required)
ID of the Project to get Runbook Snapshot for.spaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — Success
Assembledstring
Formatdate-time.FrozenProjectVariableSetIdstring
Minimum length 1.FrozenRunbookProcessIdstring
Minimum length 1.GitReferenceobjectGitCommitstringGitRefstringVariablesGitCommitstring
Idstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LibraryVariableSetSnapshotIdsarray of string
Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Minimum length 1.NotesstringProjectIdstringProjectVariableSetSnapshotIdstring
Minimum length 1.RunbookIdstringSelectedGitResourcesarray of objectActionNamestring
Minimum length 1.GitReferenceResourceobjectGitResourceReferenceNamestring
SelectedPackagesarray of objectActionNamestringPackageReferenceNamestringStepNamestringVersionstring
SpaceIdstring
Example Response
{
"Assembled": "2020-01-01T00:00:00.000Z",
"FrozenProjectVariableSetId": "string",
"FrozenRunbookProcessId": "string",
"GitReference": {
"GitCommit": "string",
"GitRef": "string",
"VariablesGitCommit": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LibraryVariableSetSnapshotIds": [
"string"
],
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Notes": "string",
"ProjectId": "Projects-1",
"ProjectVariableSetSnapshotId": "string",
"RunbookId": "Runbooks-1",
"SelectedGitResources": [
{
"ActionName": "string",
"GitReferenceResource": {
"GitCommit": "string",
"GitRef": "string"
},
"GitResourceReferenceName": "string"
}
],
"SelectedPackages": [
{
"ActionName": "string",
"PackageReferenceName": "string",
"StepName": "string",
"Version": "string"
}
],
"SpaceId": "Spaces-1"
}Modify a Runbook Snapshot
PUT /api
Also reachable at /api, /api.
Path Parameters
idstring (required)
ID of the runbook snapshot to modify.projectIdstring (required)
ID of the project that owns the runbook.spaceIdstring (required)
The ID of the space containing the resource(s).
Request Body
Idstring (required)
ID of the runbook snapshot to modify.Namestring (required)
The name of the runbook snapshot. Minimum length 1.Notesstring
Any additional information about the runbook snapshot.ProjectIdstring
Not used to locate the snapshot; the snapshot ID alone finds it. Safe to omit.SelectedGitResourcesarray of object
The git resources and versions used in the runbook snapshot.ActionNamestring (required)
Minimum length 1.GitReferenceResourceobject (required)GitResourceReferenceNamestring
SelectedPackagesarray of object
The packages and versions used in the runbook snapshot.ActionNamestringPackageReferenceNamestringStepNamestringVersionstring
SpaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — Confirmation that the Runbook Snapshot was modified, containing the updated snapshot
Assembledstring
Formatdate-time.FrozenProjectVariableSetIdstring
Minimum length 1.FrozenRunbookProcessIdstring
Minimum length 1.GitReferenceobjectGitCommitstringGitRefstringVariablesGitCommitstring
Idstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LibraryVariableSetSnapshotIdsarray of string
Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Minimum length 1.NotesstringProjectIdstringProjectVariableSetSnapshotIdstring
Minimum length 1.RunbookIdstringSelectedGitResourcesarray of objectActionNamestring
Minimum length 1.GitReferenceResourceobjectGitResourceReferenceNamestring
SelectedPackagesarray of objectActionNamestringPackageReferenceNamestringStepNamestringVersionstring
SpaceIdstring
Example Request
{
"Id": "string",
"Name": "string",
"Notes": "string",
"ProjectId": "Projects-1",
"SelectedGitResources": [
{
"ActionName": "string",
"GitReferenceResource": {
"GitCommit": "string",
"GitRef": "string"
},
"GitResourceReferenceName": "string"
}
],
"SelectedPackages": [
{
"ActionName": "string",
"PackageReferenceName": "string",
"StepName": "string",
"Version": "string"
}
],
"SpaceId": "Spaces-1"
}Example Response
{
"Assembled": "2020-01-01T00:00:00.000Z",
"FrozenProjectVariableSetId": "string",
"FrozenRunbookProcessId": "string",
"GitReference": {
"GitCommit": "string",
"GitRef": "string",
"VariablesGitCommit": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LibraryVariableSetSnapshotIds": [
"string"
],
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Notes": "string",
"ProjectId": "Projects-1",
"ProjectVariableSetSnapshotId": "string",
"RunbookId": "Runbooks-1",
"SelectedGitResources": [
{
"ActionName": "string",
"GitReferenceResource": {
"GitCommit": "string",
"GitRef": "string"
},
"GitResourceReferenceName": "string"
}
],
"SelectedPackages": [
{
"ActionName": "string",
"PackageReferenceName": "string",
"StepName": "string",
"Version": "string"
}
],
"SpaceId": "Spaces-1"
}Get the runbook runs for the given snapshot
GET /api
Also reachable at /api, /api.
Path Parameters
idstring (required)projectIdstring (required)spaceIdstring (required)
Query Parameters
skipinteger
Number of items to skip. Defaults to zero. Minimum0.takeinteger
Number of items to take. Defaults to 30. Minimum0.
Response
200 — Contains the Runbook Runs for the given Runbook Snapshot.
Idstring
Gets or sets a unique identifier for this resource.ItemTypestringItemsarray of objectChangeRequestSettingsarray of objectCommentsstringCreatedstring
Formatdate-time.DebugModestringDeployedBystringDeployedByIdstringDeployedToMachineIdsarray of stringEnvironmentIdstringExcludedMachineIdsarray of string
A collection of machines in the target environment that should be excluded from the deployment.ExcludedTargetTagIdsarray of string
A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.ExecutionPlanLogContextobjectFailTargetDiscoverybooleanFailureEncounteredbooleanForcePackageDownloadbooleanFormValuesobjectFrozenRunbookProcessIdstringIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.ManifestVariableSetIdstringNamestringPrioritystringProjectIdstringQueueTimestring
If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Formatdate-time.QueueTimeExpirystring
Formatdate-time.RunbookIdstring
Minimum length 1.RunbookNamestringRunbookSnapshotIdstring
Minimum length 1.SkipActionsarray of stringSpaceIdstringSpecificMachineIdsarray of string
A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.SpecificTargetTagIdsarray of string
A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.TaskIdstringTenantIdstringTentacleRetentionPeriodobjectUseGuidedFailureboolean
If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
ItemsPerPageintegerLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LastPageNumberintegerLinksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NumberOfPagesintegerTotalResultsinteger
Example Response
{
"Id": "string",
"ItemType": "string",
"Items": [
{
"ChangeRequestSettings": [
{}
],
"Comments": "string",
"Created": "2020-01-01T00:00:00.000Z",
"DebugMode": "string",
"DeployedBy": "string",
"DeployedById": "string",
"DeployedToMachineIds": [
"string"
],
"EnvironmentId": "Environments-1",
"ExcludedMachineIds": [
"string"
],
"ExcludedTargetTagIds": [
"string"
],
"ExecutionPlanLogContext": {
"Steps": [
{}
]
},
"FailTargetDiscovery": true,
"FailureEncountered": true,
"ForcePackageDownload": true,
"FormValues": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"FrozenRunbookProcessId": "string",
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"ManifestVariableSetId": "string",
"Name": "string",
"Priority": "string",
"ProjectId": "Projects-1",
"QueueTime": "2020-01-01T00:00:00.000Z",
"QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
"RunbookId": "string",
"RunbookName": "string",
"RunbookSnapshotId": "string",
"SkipActions": [
"string"
],
"SpaceId": "Spaces-1",
"SpecificMachineIds": [
"string"
],
"SpecificTargetTagIds": [
"string"
],
"TaskId": "ServerTasks-1",
"TenantId": "Tenants-1",
"TentacleRetentionPeriod": {
"QuantityToKeep": 0,
"ShouldKeepForever": true,
"Strategy": "string",
"Unit": "Days"
},
"UseGuidedFailure": true
}
],
"ItemsPerPage": 0,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LastPageNumber": 0,
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"NumberOfPages": 0,
"TotalResults": 0
}Get a Runbook Run Preview for a Runbook Snapshot
GET /api
Also reachable at /api, /api, /api, /api, /api.
Gets a document that describes what steps will/won’t be run during a run to a given environment (and tenant if supplied)
Path Parameters
environmentIdstring (required)
ID of the Environment.idstring (required)
ID of the Runbook Snapshot.projectIdstring (required)
ID of the Project.spaceIdstring (required)
The ID of the space containing the resource(s).
Query Parameters
includeDisabledStepsboolean
Boolean to include/exclude disabled steps from response.tenantstring
ID of the Tenant.
Response
200 — The requested Runbook Run preview
FormobjectElementsarray of object
Elements of the form.Valuesobject
Values supplied for the form elements.
Idstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.StepsToExecutearray of objectActionIdstringActionNamestringActionNumberstringAvailableTagSetsarray of objectCanBeSkippedbooleanExcludedMachinesarray of objectHasNoApplicableMachinesbooleanIsDisabledbooleanMachineNamesarray of stringMachinesarray of objectRolesarray of stringUnavailableMachinesarray of object
UseGuidedFailureModeByDefaultboolean
Example Response
{
"Form": {
"Elements": [
{
"Control": {},
"IsValueRequired": true,
"Name": "string"
}
],
"Values": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
}
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"StepsToExecute": [
{
"ActionId": "string",
"ActionName": "string",
"ActionNumber": "string",
"AvailableTagSets": [
{}
],
"CanBeSkipped": true,
"ExcludedMachines": [
{}
],
"HasNoApplicableMachines": true,
"IsDisabled": true,
"MachineNames": [
"string"
],
"Machines": [
{}
],
"Roles": [
"string"
],
"UnavailableMachines": [
{}
]
}
],
"UseGuidedFailureModeByDefault": true
}Get a Runbook Run Template for a Runbook Snapshot
GET /api
Also reachable at /api, /api.
Gets all of the information necessary for creating or editing a run for this snapshot.
Path Parameters
idstring (required)
ID of the Runbook Snapshot to get a Runbook Run Template for.projectIdstring (required)
ID of the Project the Runbook Snapshot belongs to.spaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — The requested Runbook Run Template
Idstring
Gets or sets a unique identifier for this resource.IsGitResourceModifiedbooleanIsLibraryVariableSetModifiedbooleanIsRunbookProcessModifiedbooleanIsVariableSetModifiedbooleanLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.PromoteToarray of objectIdstringLinksobjectNamestring
TenantPromotionsarray of objectIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NamestringPromoteToarray of object
Example Response
{
"Id": "string",
"IsGitResourceModified": true,
"IsLibraryVariableSetModified": true,
"IsRunbookProcessModified": true,
"IsVariableSetModified": true,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"PromoteTo": [
{
"Id": "Environments-1",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string"
}
],
"TenantPromotions": [
{
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"PromoteTo": [
{}
]
}
]
}Update the variable snapshots for a Runbook Snapshot
POST /api
Also reachable at /api, /api.
Update the variable snapshots associated with the runbook snapshot to the latest versions. The runbook’s process must not have changed since the snapshot was created.
Path Parameters
idstring (required)
ID of the Runbook Snapshot.projectIdstring (required)
The ID of the project containing this resource. Will be inferred if not provided.spaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — Confirmation that the Runbook Snapshot Variables were refreshed, containing the updated Snapshot
Assembledstring
Formatdate-time.FrozenProjectVariableSetIdstring
Minimum length 1.FrozenRunbookProcessIdstring
Minimum length 1.GitReferenceobjectGitCommitstringGitRefstringVariablesGitCommitstring
Idstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LibraryVariableSetSnapshotIdsarray of string
Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Minimum length 1.NotesstringProjectIdstringProjectVariableSetSnapshotIdstring
Minimum length 1.RunbookIdstringSelectedGitResourcesarray of objectActionNamestring
Minimum length 1.GitReferenceResourceobjectGitResourceReferenceNamestring
SelectedPackagesarray of objectActionNamestringPackageReferenceNamestringStepNamestringVersionstring
SpaceIdstring
Example Response
{
"Assembled": "2020-01-01T00:00:00.000Z",
"FrozenProjectVariableSetId": "string",
"FrozenRunbookProcessId": "string",
"GitReference": {
"GitCommit": "string",
"GitRef": "string",
"VariablesGitCommit": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LibraryVariableSetSnapshotIds": [
"string"
],
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Notes": "string",
"ProjectId": "Projects-1",
"ProjectVariableSetSnapshotId": "string",
"RunbookId": "Runbooks-1",
"SelectedGitResources": [
{
"ActionName": "string",
"GitReferenceResource": {
"GitCommit": "string",
"GitRef": "string"
},
"GitResourceReferenceName": "string"
}
],
"SelectedPackages": [
{
"ActionName": "string",
"PackageReferenceName": "string",
"StepName": "string",
"Version": "string"
}
],
"SpaceId": "Spaces-1"
}Update the variable snapshots for a Runbook Snapshot
POST /api
Also reachable at /api, /api.
Update the variable snapshots associated with the runbook snapshot to the latest versions. The runbook’s process must not have changed since the snapshot was created.
Path Parameters
idstring (required)
ID of the Runbook Snapshot.projectIdstring (required)
The ID of the project containing this resource. Will be inferred if not provided.spaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — Confirmation that the Runbook Snapshot Variables were refreshed, containing the updated Snapshot
ResourceobjectAssembledstring
Formatdate-time.FrozenProjectVariableSetIdstring
Minimum length 1.FrozenRunbookProcessIdstring
Minimum length 1.GitReferenceobjectIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LibraryVariableSetSnapshotIdsarray of string
Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Minimum length 1.NotesstringProjectIdstringProjectVariableSetSnapshotIdstring
Minimum length 1.RunbookIdstringSelectedGitResourcesarray of objectSelectedPackagesarray of objectSpaceIdstring
Example Response
{
"Resource": {
"Assembled": "2020-01-01T00:00:00.000Z",
"FrozenProjectVariableSetId": "string",
"FrozenRunbookProcessId": "string",
"GitReference": {
"GitCommit": "string",
"GitRef": "string",
"VariablesGitCommit": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LibraryVariableSetSnapshotIds": [
"string"
],
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Notes": "string",
"ProjectId": "Projects-1",
"ProjectVariableSetSnapshotId": "string",
"RunbookId": "Runbooks-1",
"SelectedGitResources": [
{
"ActionName": "string",
"GitReferenceResource": {},
"GitResourceReferenceName": "string"
}
],
"SelectedPackages": [
{
"ActionName": "string",
"PackageReferenceName": "string",
"StepName": "string",
"Version": "string"
}
],
"SpaceId": "Spaces-1"
}
}Get a list of Variable Sets included in the Runbook Snapshot’s current Variable Snapshot
GET /api
Also reachable at /api, /api.
Path Parameters
idstring (required)
ID of the Runbook Snapshot to get variables for.projectIdstring (required)
ID of the Project the Runbook Snapshot is in.spaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — The requested list of Runbook Snapshot Variables
Idstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.OwnerIdstring
Gets or sets the ID of the document that owns these variables.ScopeValuesobjectActionsarray of objectChannelsarray of objectEnvironmentParametersarray of objectEnvironmentsarray of objectMachinesarray of objectProcessTemplateStepsarray of objectProcessesarray of objectRolesarray of objectTargetTagParametersarray of objectTenantTagParametersarray of objectTenantTagsarray of object
SpaceIdstringVariablesarray of object
Gets the collection of variables.DescriptionstringIdstringIsEditablebooleanIsSensitivebooleanNamestringPromptobjectScopeobjectTypestringValuestring
Versioninteger
Gets or sets the version number.
Example Response
[
{
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"OwnerId": "string",
"ScopeValues": {
"Actions": [
{}
],
"Channels": [
{}
],
"EnvironmentParameters": [
{}
],
"Environments": [
{}
],
"Machines": [
{}
],
"ProcessTemplateSteps": [
{}
],
"Processes": [
{}
],
"Roles": [
{}
],
"TargetTagParameters": [
{}
],
"TenantTagParameters": [
{}
],
"TenantTags": [
{}
]
},
"SpaceId": "Spaces-1",
"Variables": [
{
"Description": "string",
"Id": "string",
"IsEditable": true,
"IsSensitive": true,
"Name": "string",
"Prompt": {},
"Scope": {},
"Type": "string",
"Value": "string"
}
],
"Version": 0
}
]Get a list of Runbook Run Previews for a Runbook Snapshot
POST /api
Also reachable at /api, /api.
Path Parameters
projectIdstring (required)
ID of the Project.runbookSnapshotIdstring (required)
ID of the Runbook Snapshot.spaceIdstring (required)
The ID of the space containing the resource(s).
Request Body
DeploymentPreviewsarray of object (required)
The environment/tenant combinations to preview, one entry per combination. Leave an entry’s TenantId unset to preview an untenanted run in that environment.EnvironmentIdstringTenantIdstring
IncludeDisabledStepsboolean
Boolean to include/exclude disabled steps from response.ProjectIdstring (required)
ID of the Project.RunbookSnapshotIdstring (required)
ID of the Runbook Snapshot.SpaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — A preview for a Runbook run, representing the planned execution.
FormobjectElementsarray of object
Elements of the form.Valuesobject
Values supplied for the form elements.
Idstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.StepsToExecutearray of objectActionIdstringActionNamestringActionNumberstringAvailableTagSetsarray of objectCanBeSkippedbooleanExcludedMachinesarray of objectHasNoApplicableMachinesbooleanIsDisabledbooleanMachineNamesarray of stringMachinesarray of objectRolesarray of stringUnavailableMachinesarray of object
UseGuidedFailureModeByDefaultboolean
Example Request
{
"DeploymentPreviews": [
{
"EnvironmentId": "Environments-1",
"TenantId": "Tenants-1"
}
],
"IncludeDisabledSteps": true,
"ProjectId": "Projects-1",
"RunbookSnapshotId": "string",
"SpaceId": "Spaces-1"
}Example Response
[
{
"Form": {
"Elements": [
{}
],
"Values": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
}
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"StepsToExecute": [
{
"ActionId": "string",
"ActionName": "string",
"ActionNumber": "string",
"AvailableTagSets": [
{}
],
"CanBeSkipped": true,
"ExcludedMachines": [
{}
],
"HasNoApplicableMachines": true,
"IsDisabled": true,
"MachineNames": [
"string"
],
"Machines": [
{}
],
"Roles": [
"string"
],
"UnavailableMachines": [
{}
]
}
],
"UseGuidedFailureModeByDefault": true
}
]Get a paginated list of all of the Runbook Snapshots that belong to the given Runbook
GET /api
Also reachable at /api, /api.
Runbook Snapshots will be ordered from most recent to least recent.
Path Parameters
idstring (required)
ID of the runbook to get runbook Snapshots for.projectIdstring (required)
The ID of the project the runbook belongs to.spaceIdstring (required)
The ID of the space containing the resource(s).
Query Parameters
searchByNamestring
A partial or complete name to search on. This will perform a “contains” style match against the supplied name or name-fragment.skipinteger
Number of items to skip. Defaults to zero. Minimum0.takeinteger
Number of items to take. Defaults to 30. Minimum0.
Response
200 — A paginated list of all of the Runbook Snapshots that belong to the given Runbook.
Idstring
Gets or sets a unique identifier for this resource.ItemTypestringItemsarray of objectAssembledstring
Formatdate-time.FrozenProjectVariableSetIdstring
Minimum length 1.FrozenRunbookProcessIdstring
Minimum length 1.GitReferenceobjectIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LibraryVariableSetSnapshotIdsarray of string
Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Minimum length 1.NotesstringProjectIdstringProjectVariableSetSnapshotIdstring
Minimum length 1.RunbookIdstringSelectedGitResourcesarray of objectSelectedPackagesarray of objectSpaceIdstring
ItemsPerPageintegerLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LastPageNumberintegerLinksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NumberOfPagesintegerTotalResultsinteger
Example Response
{
"Id": "string",
"ItemType": "string",
"Items": [
{
"Assembled": "2020-01-01T00:00:00.000Z",
"FrozenProjectVariableSetId": "string",
"FrozenRunbookProcessId": "string",
"GitReference": {
"GitCommit": "string",
"GitRef": "string",
"VariablesGitCommit": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LibraryVariableSetSnapshotIds": [
"string"
],
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Notes": "string",
"ProjectId": "Projects-1",
"ProjectVariableSetSnapshotId": "string",
"RunbookId": "Runbooks-1",
"SelectedGitResources": [
{}
],
"SelectedPackages": [
{}
],
"SpaceId": "Spaces-1"
}
],
"ItemsPerPage": 0,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LastPageNumber": 0,
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"NumberOfPages": 0,
"TotalResults": 0
}Delete an existing Runbook Snapshot
DELETE /api
Also reachable at /api, /api.
Also deletes all of the Runbook Runs, Tasks and other associated resources belonging to the Runbook Snapshot.
Path Parameters
idstring (required)
ID of the Runbook Snapshot to delete.projectIdstring (required)
ID of the Project that the Runbook Snapshot belongs to.spaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — Success
Get a paginated list of Runbook Snapshots
GET /api
Also reachable at /api, /api.
Gets a paginated list of the runbook snapshots in the supplied Octopus Deploy Space, from all projects. The results will be sorted from most recent to least recent snapshot.
Path Parameters
spaceIdstring (required)
Query Parameters
skipinteger
Number of items to skip. Defaults to zero. Minimum0.takeinteger
Number of items to take. Defaults to 30. Minimum0.
Response
200 — A paginated list of the runbook snapshots in the supplied Octopus Deploy Space, from all projects. The results will be sorted from most recent to least recent snapshot.
Idstring
Gets or sets a unique identifier for this resource.ItemTypestringItemsarray of objectAssembledstring
Formatdate-time.FrozenProjectVariableSetIdstring
Minimum length 1.FrozenRunbookProcessIdstring
Minimum length 1.GitReferenceobjectIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LibraryVariableSetSnapshotIdsarray of string
Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Minimum length 1.NotesstringProjectIdstringProjectVariableSetSnapshotIdstring
Minimum length 1.RunbookIdstringSelectedGitResourcesarray of objectSelectedPackagesarray of objectSpaceIdstring
ItemsPerPageintegerLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LastPageNumberintegerLinksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NumberOfPagesintegerTotalResultsinteger
Example Response
{
"Id": "string",
"ItemType": "string",
"Items": [
{
"Assembled": "2020-01-01T00:00:00.000Z",
"FrozenProjectVariableSetId": "string",
"FrozenRunbookProcessId": "string",
"GitReference": {
"GitCommit": "string",
"GitRef": "string",
"VariablesGitCommit": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LibraryVariableSetSnapshotIds": [
"string"
],
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Notes": "string",
"ProjectId": "Projects-1",
"ProjectVariableSetSnapshotId": "string",
"RunbookId": "Runbooks-1",
"SelectedGitResources": [
{}
],
"SelectedPackages": [
{}
],
"SpaceId": "Spaces-1"
}
],
"ItemsPerPage": 0,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LastPageNumber": 0,
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"NumberOfPages": 0,
"TotalResults": 0
}Create a Runbook Snapshot
POST /api
Also reachable at /api, /api.
Path Parameters
spaceIdstring (required)
The ID of the space containing the resource(s).
Request Body
Namestring (required)
The name of the runbook snapshot. Minimum length 1.Notesstring
Any additional information about the runbook snapshot.ProjectIdstring (required)
ID of the project that owns the runbook to snapshot.Publishstring
Publishes the snapshot when set to any non-blank value, making it the snapshot that runbook triggers and ‘published’ runs use. The value itself is not stored. Leave unset to create the snapshot without publishing it.RunbookIdstring (required)
ID of the runbook to snapshot.SelectedGitResourcesarray of objectActionNamestring (required)
Minimum length 1.GitReferenceResourceobject (required)GitResourceReferenceNamestring
SelectedPackagesarray of object
The packages and versions used in the runbook snapshot.ActionNamestringPackageReferenceNamestringStepNamestringVersionstring
SpaceIdstring (required)
The ID of the space containing the resource(s).
Response
201 — Created
Assembledstring
Formatdate-time.FrozenProjectVariableSetIdstring
Minimum length 1.FrozenRunbookProcessIdstring
Minimum length 1.GitReferenceobjectGitCommitstringGitRefstringVariablesGitCommitstring
Idstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LibraryVariableSetSnapshotIdsarray of string
Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Minimum length 1.NotesstringProjectIdstringProjectVariableSetSnapshotIdstring
Minimum length 1.RunbookIdstringSelectedGitResourcesarray of objectActionNamestring
Minimum length 1.GitReferenceResourceobjectGitResourceReferenceNamestring
SelectedPackagesarray of objectActionNamestringPackageReferenceNamestringStepNamestringVersionstring
SpaceIdstring
Example Request
{
"Name": "string",
"Notes": "string",
"ProjectId": "Projects-1",
"Publish": "string",
"RunbookId": "Runbooks-1",
"SelectedGitResources": [
{
"ActionName": "string",
"GitReferenceResource": {
"GitCommit": "string",
"GitRef": "string"
},
"GitResourceReferenceName": "string"
}
],
"SelectedPackages": [
{
"ActionName": "string",
"PackageReferenceName": "string",
"StepName": "string",
"Version": "string"
}
],
"SpaceId": "Spaces-1"
}Example Response
{
"Assembled": "2020-01-01T00:00:00.000Z",
"FrozenProjectVariableSetId": "string",
"FrozenRunbookProcessId": "string",
"GitReference": {
"GitCommit": "string",
"GitRef": "string",
"VariablesGitCommit": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LibraryVariableSetSnapshotIds": [
"string"
],
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Notes": "string",
"ProjectId": "Projects-1",
"ProjectVariableSetSnapshotId": "string",
"RunbookId": "Runbooks-1",
"SelectedGitResources": [
{
"ActionName": "string",
"GitReferenceResource": {
"GitCommit": "string",
"GitRef": "string"
},
"GitResourceReferenceName": "string"
}
],
"SelectedPackages": [
{
"ActionName": "string",
"PackageReferenceName": "string",
"StepName": "string",
"Version": "string"
}
],
"SpaceId": "Spaces-1"
}Get a Runbook Snapshot by ID
GET /api
Also reachable at /api, /api.
Path Parameters
idstring (required)
ID of the RunbookSnapshot to retrieve.spaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — The requested runbook snapshot
Assembledstring
Formatdate-time.FrozenProjectVariableSetIdstring
Minimum length 1.FrozenRunbookProcessIdstring
Minimum length 1.GitReferenceobjectGitCommitstringGitRefstringVariablesGitCommitstring
Idstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LibraryVariableSetSnapshotIdsarray of string
Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Minimum length 1.NotesstringProjectIdstringProjectVariableSetSnapshotIdstring
Minimum length 1.RunbookIdstringSelectedGitResourcesarray of objectActionNamestring
Minimum length 1.GitReferenceResourceobjectGitResourceReferenceNamestring
SelectedPackagesarray of objectActionNamestringPackageReferenceNamestringStepNamestringVersionstring
SpaceIdstring
Example Response
{
"Assembled": "2020-01-01T00:00:00.000Z",
"FrozenProjectVariableSetId": "string",
"FrozenRunbookProcessId": "string",
"GitReference": {
"GitCommit": "string",
"GitRef": "string",
"VariablesGitCommit": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LibraryVariableSetSnapshotIds": [
"string"
],
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Notes": "string",
"ProjectId": "Projects-1",
"ProjectVariableSetSnapshotId": "string",
"RunbookId": "Runbooks-1",
"SelectedGitResources": [
{
"ActionName": "string",
"GitReferenceResource": {
"GitCommit": "string",
"GitRef": "string"
},
"GitResourceReferenceName": "string"
}
],
"SelectedPackages": [
{
"ActionName": "string",
"PackageReferenceName": "string",
"StepName": "string",
"Version": "string"
}
],
"SpaceId": "Spaces-1"
}Modify a Runbook Snapshot
PUT /api
Also reachable at /api, /api.
Path Parameters
idstring (required)
ID of the runbook snapshot to modify.spaceIdstring (required)
The ID of the space containing the resource(s).
Request Body
Idstring (required)
ID of the runbook snapshot to modify.Namestring (required)
The name of the runbook snapshot. Minimum length 1.Notesstring
Any additional information about the runbook snapshot.ProjectIdstring
Not used to locate the snapshot; the snapshot ID alone finds it. Safe to omit.SelectedGitResourcesarray of object
The git resources and versions used in the runbook snapshot.ActionNamestring (required)
Minimum length 1.GitReferenceResourceobject (required)GitResourceReferenceNamestring
SelectedPackagesarray of object
The packages and versions used in the runbook snapshot.ActionNamestringPackageReferenceNamestringStepNamestringVersionstring
SpaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — Confirmation that the Runbook Snapshot was modified, containing the updated snapshot
Assembledstring
Formatdate-time.FrozenProjectVariableSetIdstring
Minimum length 1.FrozenRunbookProcessIdstring
Minimum length 1.GitReferenceobjectGitCommitstringGitRefstringVariablesGitCommitstring
Idstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LibraryVariableSetSnapshotIdsarray of string
Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Minimum length 1.NotesstringProjectIdstringProjectVariableSetSnapshotIdstring
Minimum length 1.RunbookIdstringSelectedGitResourcesarray of objectActionNamestring
Minimum length 1.GitReferenceResourceobjectGitResourceReferenceNamestring
SelectedPackagesarray of objectActionNamestringPackageReferenceNamestringStepNamestringVersionstring
SpaceIdstring
Example Request
{
"Id": "string",
"Name": "string",
"Notes": "string",
"ProjectId": "Projects-1",
"SelectedGitResources": [
{
"ActionName": "string",
"GitReferenceResource": {
"GitCommit": "string",
"GitRef": "string"
},
"GitResourceReferenceName": "string"
}
],
"SelectedPackages": [
{
"ActionName": "string",
"PackageReferenceName": "string",
"StepName": "string",
"Version": "string"
}
],
"SpaceId": "Spaces-1"
}Example Response
{
"Assembled": "2020-01-01T00:00:00.000Z",
"FrozenProjectVariableSetId": "string",
"FrozenRunbookProcessId": "string",
"GitReference": {
"GitCommit": "string",
"GitRef": "string",
"VariablesGitCommit": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LibraryVariableSetSnapshotIds": [
"string"
],
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Notes": "string",
"ProjectId": "Projects-1",
"ProjectVariableSetSnapshotId": "string",
"RunbookId": "Runbooks-1",
"SelectedGitResources": [
{
"ActionName": "string",
"GitReferenceResource": {
"GitCommit": "string",
"GitRef": "string"
},
"GitResourceReferenceName": "string"
}
],
"SelectedPackages": [
{
"ActionName": "string",
"PackageReferenceName": "string",
"StepName": "string",
"Version": "string"
}
],
"SpaceId": "Spaces-1"
}Get the runbook runs for the given snapshot
GET /api
Also reachable at /api, /api.
Path Parameters
idstring (required)spaceIdstring (required)
Query Parameters
skipinteger
Number of items to skip. Defaults to zero. Minimum0.takeinteger
Number of items to take. Defaults to 30. Minimum0.
Response
200 — Contains the Runbook Runs for the given Runbook Snapshot.
Idstring
Gets or sets a unique identifier for this resource.ItemTypestringItemsarray of objectChangeRequestSettingsarray of objectCommentsstringCreatedstring
Formatdate-time.DebugModestringDeployedBystringDeployedByIdstringDeployedToMachineIdsarray of stringEnvironmentIdstringExcludedMachineIdsarray of string
A collection of machines in the target environment that should be excluded from the deployment.ExcludedTargetTagIdsarray of string
A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.ExecutionPlanLogContextobjectFailTargetDiscoverybooleanFailureEncounteredbooleanForcePackageDownloadbooleanFormValuesobjectFrozenRunbookProcessIdstringIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.ManifestVariableSetIdstringNamestringPrioritystringProjectIdstringQueueTimestring
If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Formatdate-time.QueueTimeExpirystring
Formatdate-time.RunbookIdstring
Minimum length 1.RunbookNamestringRunbookSnapshotIdstring
Minimum length 1.SkipActionsarray of stringSpaceIdstringSpecificMachineIdsarray of string
A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.SpecificTargetTagIdsarray of string
A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.TaskIdstringTenantIdstringTentacleRetentionPeriodobjectUseGuidedFailureboolean
If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
ItemsPerPageintegerLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LastPageNumberintegerLinksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NumberOfPagesintegerTotalResultsinteger
Example Response
{
"Id": "string",
"ItemType": "string",
"Items": [
{
"ChangeRequestSettings": [
{}
],
"Comments": "string",
"Created": "2020-01-01T00:00:00.000Z",
"DebugMode": "string",
"DeployedBy": "string",
"DeployedById": "string",
"DeployedToMachineIds": [
"string"
],
"EnvironmentId": "Environments-1",
"ExcludedMachineIds": [
"string"
],
"ExcludedTargetTagIds": [
"string"
],
"ExecutionPlanLogContext": {
"Steps": [
{}
]
},
"FailTargetDiscovery": true,
"FailureEncountered": true,
"ForcePackageDownload": true,
"FormValues": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"FrozenRunbookProcessId": "string",
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"ManifestVariableSetId": "string",
"Name": "string",
"Priority": "string",
"ProjectId": "Projects-1",
"QueueTime": "2020-01-01T00:00:00.000Z",
"QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
"RunbookId": "string",
"RunbookName": "string",
"RunbookSnapshotId": "string",
"SkipActions": [
"string"
],
"SpaceId": "Spaces-1",
"SpecificMachineIds": [
"string"
],
"SpecificTargetTagIds": [
"string"
],
"TaskId": "ServerTasks-1",
"TenantId": "Tenants-1",
"TentacleRetentionPeriod": {
"QuantityToKeep": 0,
"ShouldKeepForever": true,
"Strategy": "string",
"Unit": "Days"
},
"UseGuidedFailure": true
}
],
"ItemsPerPage": 0,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LastPageNumber": 0,
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"NumberOfPages": 0,
"TotalResults": 0
}Get a Runbook Run Preview for a Runbook Snapshot
GET /api
Also reachable at /api, /api, /api, /api, /api.
Gets a document that describes what steps will/won’t be run during a run to a given environment (and tenant if supplied)
Path Parameters
environmentIdstring (required)
ID of the Environment.idstring (required)
ID of the Runbook Snapshot.spaceIdstring (required)
The ID of the space containing the resource(s).
Query Parameters
includeDisabledStepsboolean
Boolean to include/exclude disabled steps from response.projectIdstring
ID of the Project.tenantstring
ID of the Tenant.
Response
200 — The requested Runbook Run preview
FormobjectElementsarray of object
Elements of the form.Valuesobject
Values supplied for the form elements.
Idstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.StepsToExecutearray of objectActionIdstringActionNamestringActionNumberstringAvailableTagSetsarray of objectCanBeSkippedbooleanExcludedMachinesarray of objectHasNoApplicableMachinesbooleanIsDisabledbooleanMachineNamesarray of stringMachinesarray of objectRolesarray of stringUnavailableMachinesarray of object
UseGuidedFailureModeByDefaultboolean
Example Response
{
"Form": {
"Elements": [
{
"Control": {},
"IsValueRequired": true,
"Name": "string"
}
],
"Values": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
}
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"StepsToExecute": [
{
"ActionId": "string",
"ActionName": "string",
"ActionNumber": "string",
"AvailableTagSets": [
{}
],
"CanBeSkipped": true,
"ExcludedMachines": [
{}
],
"HasNoApplicableMachines": true,
"IsDisabled": true,
"MachineNames": [
"string"
],
"Machines": [
{}
],
"Roles": [
"string"
],
"UnavailableMachines": [
{}
]
}
],
"UseGuidedFailureModeByDefault": true
}Get a Runbook Run Template for a Runbook Snapshot
GET /api
Also reachable at /api, /api.
Gets all of the information necessary for creating or editing a run for this snapshot.
Path Parameters
idstring (required)
ID of the Runbook Snapshot to get a Runbook Run Template for.spaceIdstring (required)
The ID of the space containing the resource(s).
Query Parameters
projectIdstring
ID of the Project the Runbook Snapshot belongs to.
Response
200 — The requested Runbook Run Template
Idstring
Gets or sets a unique identifier for this resource.IsGitResourceModifiedbooleanIsLibraryVariableSetModifiedbooleanIsRunbookProcessModifiedbooleanIsVariableSetModifiedbooleanLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.PromoteToarray of objectIdstringLinksobjectNamestring
TenantPromotionsarray of objectIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NamestringPromoteToarray of object
Example Response
{
"Id": "string",
"IsGitResourceModified": true,
"IsLibraryVariableSetModified": true,
"IsRunbookProcessModified": true,
"IsVariableSetModified": true,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"PromoteTo": [
{
"Id": "Environments-1",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string"
}
],
"TenantPromotions": [
{
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"PromoteTo": [
{}
]
}
]
}Update the variable snapshots for a Runbook Snapshot
POST /api
Also reachable at /api, /api.
Update the variable snapshots associated with the runbook snapshot to the latest versions. The runbook’s process must not have changed since the snapshot was created.
Path Parameters
idstring (required)
ID of the Runbook Snapshot.spaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — Confirmation that the Runbook Snapshot Variables were refreshed, containing the updated Snapshot
Assembledstring
Formatdate-time.FrozenProjectVariableSetIdstring
Minimum length 1.FrozenRunbookProcessIdstring
Minimum length 1.GitReferenceobjectGitCommitstringGitRefstringVariablesGitCommitstring
Idstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LibraryVariableSetSnapshotIdsarray of string
Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Minimum length 1.NotesstringProjectIdstringProjectVariableSetSnapshotIdstring
Minimum length 1.RunbookIdstringSelectedGitResourcesarray of objectActionNamestring
Minimum length 1.GitReferenceResourceobjectGitResourceReferenceNamestring
SelectedPackagesarray of objectActionNamestringPackageReferenceNamestringStepNamestringVersionstring
SpaceIdstring
Example Response
{
"Assembled": "2020-01-01T00:00:00.000Z",
"FrozenProjectVariableSetId": "string",
"FrozenRunbookProcessId": "string",
"GitReference": {
"GitCommit": "string",
"GitRef": "string",
"VariablesGitCommit": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LibraryVariableSetSnapshotIds": [
"string"
],
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Notes": "string",
"ProjectId": "Projects-1",
"ProjectVariableSetSnapshotId": "string",
"RunbookId": "Runbooks-1",
"SelectedGitResources": [
{
"ActionName": "string",
"GitReferenceResource": {
"GitCommit": "string",
"GitRef": "string"
},
"GitResourceReferenceName": "string"
}
],
"SelectedPackages": [
{
"ActionName": "string",
"PackageReferenceName": "string",
"StepName": "string",
"Version": "string"
}
],
"SpaceId": "Spaces-1"
}Get a paginated list of all of the Runbook Snapshots that belong to the given Runbook
GET /api
Also reachable at /api, /api.
Runbook Snapshots will be ordered from most recent to least recent.
Path Parameters
idstring (required)
ID of the runbook to get runbook Snapshots for.spaceIdstring (required)
The ID of the space containing the resource(s).
Query Parameters
projectIdstring
The ID of the project the runbook belongs to.searchByNamestring
A partial or complete name to search on. This will perform a “contains” style match against the supplied name or name-fragment.skipinteger
Number of items to skip. Defaults to zero. Minimum0.takeinteger
Number of items to take. Defaults to 30. Minimum0.
Response
200 — A paginated list of all of the Runbook Snapshots that belong to the given Runbook.
Idstring
Gets or sets a unique identifier for this resource.ItemTypestringItemsarray of objectAssembledstring
Formatdate-time.FrozenProjectVariableSetIdstring
Minimum length 1.FrozenRunbookProcessIdstring
Minimum length 1.GitReferenceobjectIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LibraryVariableSetSnapshotIdsarray of string
Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Minimum length 1.NotesstringProjectIdstringProjectVariableSetSnapshotIdstring
Minimum length 1.RunbookIdstringSelectedGitResourcesarray of objectSelectedPackagesarray of objectSpaceIdstring
ItemsPerPageintegerLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LastPageNumberintegerLinksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NumberOfPagesintegerTotalResultsinteger
Example Response
{
"Id": "string",
"ItemType": "string",
"Items": [
{
"Assembled": "2020-01-01T00:00:00.000Z",
"FrozenProjectVariableSetId": "string",
"FrozenRunbookProcessId": "string",
"GitReference": {
"GitCommit": "string",
"GitRef": "string",
"VariablesGitCommit": "string"
},
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LibraryVariableSetSnapshotIds": [
"string"
],
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Notes": "string",
"ProjectId": "Projects-1",
"ProjectVariableSetSnapshotId": "string",
"RunbookId": "Runbooks-1",
"SelectedGitResources": [
{}
],
"SelectedPackages": [
{}
],
"SpaceId": "Spaces-1"
}
],
"ItemsPerPage": 0,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LastPageNumber": 0,
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"NumberOfPages": 0,
"TotalResults": 0
}Delete an existing Runbook Snapshot
DELETE /api
Also reachable at /api, /api.
Also deletes all of the Runbook Runs, Tasks and other associated resources belonging to the Runbook Snapshot.
Path Parameters
idstring (required)
ID of the Runbook Snapshot to delete.spaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — Success